#pragma once
#include <vector>
#include <cstdint>
#include <cmath>
#include "extern.h"

class mixer_track;

inline sample_t sample_to_db(sample_t sample) {
    return 20.0f * log10f(sample);
}

// convert db(-60db, 10db) to percent in range [0, 1]
inline float db_to_percent(float db) {
    return (db + 60.0f) / 70.0f;
}

void vertical_text(const char* text);

void draw_instrument_track();
void draw_mixer();
void draw_mixer_track(uint32_t delta_sample_count, mixer_track* track, int32_t index);
void draw_volume_bar(const char* id, float height, std::vector<float> sample_value, std::vector<float> sample_peak);

inline float volume_bar_peak_duration = 0.5f;
inline float volume_bar_peak_decay = 0.1f;
inline constexpr float volume_bar_inf = 0.0001f;
